﻿using System.IO;
using System;
using System.CommandLine;
using System.Threading.Tasks;
using CFUtils.Commands;

namespace CFUtils
{
    internal class Program
    {
        // See: https://docs.microsoft.com/en-us/dotnet/core/tutorials/top-level-templates
        static async Task<int> Main(string[] args)
        {
            DirectoryInfo workspace = new DirectoryInfo(Path.Combine(Path.GetTempPath(), Path.GetRandomFileName()));
            Directory.CreateDirectory(workspace.FullName);
            RootCommand rootCmd = new RootCommand("CLI utility for creating, editing, and installing Curseforge profiles.");
            rootCmd.Add(new Install(workspace));
            return await rootCmd.InvokeAsync(args);
        }
    }
}